scala.collection.mutable

# IndexedSeqOptimized

#### trait IndexedSeqOptimized[A, +Repr] extends IndexedSeqLike[A, Repr] with IndexedSeqOptimized[A, Repr]

A subtrait of scala.collection.IndexedSeq which represents sequences that can be mutated.

Source
  IndexedSeqOptimized.scala
Since

  2.8

Linear Supertypes
IndexedSeqOptimized[A, Repr], IndexedSeqLike[A, Repr], IndexedSeqLike[A, Repr], SeqLike[A, Repr], GenSeqLike[A, Repr], IterableLike[A, Repr], GenIterableLike[A, Repr], TraversableLike[A, Repr], GenTraversableLike[A, Repr], Parallelizable[A, ParSeq[A]], TraversableOnce[A], GenTraversableOnce[A], FilterMonadic[A, Repr], HasNewBuilder[A, Repr], Equals, AnyRef, Any
Known Subclasses
ArrayBuffer, ArrayLike, ArrayOps, ArraySeq, DroppedWhile, Filtered, IndexedSeqView, NodeBuffer, ResizableArray, Reversed, Script, Sliced, TakenWhile, Transformed, WrappedArray, ofBoolean, ofBoolean, ofByte, ofByte, ofChar, ofChar, ofDouble, ofDouble, ofFloat, ofFloat, ofInt, ofInt, ofLong, ofLong, ofRef, ofRef, ofShort, ofShort, ofUnit, ofUnit
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. IndexedSeqOptimized
2. IndexedSeqOptimized
3. IndexedSeqLike
4. IndexedSeqLike
5. SeqLike
6. GenSeqLike
7. IterableLike
8. GenIterableLike
9. TraversableLike
10. GenTraversableLike
11. Parallelizable
12. TraversableOnce
13. GenTraversableOnce
14. FilterMonadic
15. HasNewBuilder
16. Equals
17. AnyRef
18. Any

Visibility

1. Public
2. All

### Type Members

1. #### class Elements extends BufferedIterator[A] with Serializable

   The class of the iterator returned by the `iterator` method.

2. #### type Self = Repr

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected
   Definition Classes
     TraversableLike

3. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

### Abstract Value Members

1. #### abstract def apply(idx: Int): A

   Selects an element by its index in the mutable indexed sequence.

   Selects an element by its index in the mutable indexed sequence.

   Example:

          scala> val x = LinkedList(1, 2, 3, 4, 5)
          x: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4, 5)

          scala> x(3)
          res1: Int = 4

   idx

     The index to select.

   returns

     the element of this mutable indexed sequence at index `idx`, where `0` indicates the first element.

   Definition Classes
     SeqLike → GenSeqLike
   Exceptions thrown
     `IndexOutOfBoundsException`

     if `idx` does not satisfy `0 <= idx < length`.

2. #### abstract def length: Int

   The length of the mutable indexed sequence.

   The length of the mutable indexed sequence.

   Note: `xs.length` and `xs.size` yield the same result.

   returns

     the number of elements in this mutable indexed sequence.

   Definition Classes
     SeqLike → GenSeqLike

3. #### abstract def newBuilder: Builder[A, Repr]

   Creates a new builder for this collection type.

   Creates a new builder for this collection type.

   Attributes
     protected[this]
   Definition Classes
     TraversableLike → HasNewBuilder

4. #### abstract def seq: TraversableOnce[A]

   Definition Classes
     Parallelizable

5. #### abstract def update(idx: Int, elem: A): Unit

   Replaces element at given index with a new value.

   Replaces element at given index with a new value.

   elem

     the new value.

   Definition Classes
     IndexedSeqLike
   Exceptions thrown
     IndexOutOfBoundsException

     if the index is not valid.

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### abstract def ++[B](that: GenTraversableOnce[B]): IndexedSeq[B]

   [use case] Returns a new mutable indexed sequence containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new mutable indexed sequence containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the mutable indexed sequence is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this mutable indexed sequence followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

5. #### def ++[B >: A, That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

   Returns a new mutable indexed sequence containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new mutable indexed sequence containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the mutable indexed sequence is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this mutable indexed sequence followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike

6. #### def ++:[B >: A, That](that: Traversable[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand. It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new mutable indexed sequence which contains all elements of this mutable indexed sequence followed by all elements of `that`.

   Definition Classes
     TraversableLike

7. #### abstract def ++:[B](that: TraversableOnce[B]): IndexedSeq[B]

   [use case] Concatenates this mutable indexed sequence with the elements of a traversable collection.

   [use case]

   Concatenates this mutable indexed sequence with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this mutable indexed sequence followed by all elements of `that`.

   Definition Classes
     TraversableLike

8. #### def ++:[B >: A, That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

   Concatenates this mutable indexed sequence with the elements of a traversable collection.

   Concatenates this mutable indexed sequence with the elements of a traversable collection. It differs from ++ in that the right operand determines the type of the resulting collection rather than the left one.

   Example:

           scala> val x = List(1)
           x: List[Int] = List(1)

           scala> val y = LinkedList(2)
           y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val z = x ++: y
           z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this mutable indexed sequence followed by all elements of `that`.

   Definition Classes
     TraversableLike

9. #### abstract def +:(elem: A): IndexedSeq[A]

   [use case] A copy of the mutable indexed sequence with an element prepended.

   [use case]

   A copy of the mutable indexed sequence with an element prepended.

   elem

     the prepended element

   returns

     a new collection of type `That` consisting of `elem` followed by all elements of this mutable indexed sequence.

   Definition Classes
     GenSeqLike

10. #### def +:[B >: A, That](elem: B)(implicit bf: CanBuildFrom[Repr, B, That]): That

    A copy of the mutable indexed sequence with an element prepended.

    A copy of the mutable indexed sequence with an element prepended.

    Note that :-ending operators are right associative (see example). Also, the original mutable indexed sequence is not modified, so you will want to capture the result.

    Example:

             scala> val x = LinkedList(1)
             x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

             scala> val y = 2 +: x
             y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

             scala> println(x)
             LinkedList(1)

    B

      the element type of the returned mutable indexed sequence.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    elem

      the prepended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` consisting of `elem` followed by all elements of this mutable indexed sequence.

    Definition Classes
      SeqLike → GenSeqLike

11. #### def /:[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this mutable indexed sequence, going left to right.

    Applies a binary operator to a start value and all elements of this mutable indexed sequence, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (5 /: a)(_+_)
             b: Int = 15

             scala> val c = (5 /: a)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this mutable indexed sequence, going left to right with the start value `z` on the left:

                      op(...op(op(z, x1), x2), ..., xn)

      where `x1, ..., xn` are the elements of this mutable indexed sequence.

    Definition Classes
      TraversableOnce → GenTraversableOnce

12. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    A syntactic sugar for out of order folding.

    A syntactic sugar for out of order folding. See `fold`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a /:\ 5)(_+_)
             b: Int = 15

    Definition Classes
      GenTraversableOnce

13. #### abstract def :+(elem: A): IndexedSeq[A]

    [use case] A copy of this mutable indexed sequence with an element appended.

    [use case]

    A copy of this mutable indexed sequence with an element appended.

    elem

      the appended element

    returns

      a new collection of type `That` consisting of all elements of this mutable indexed sequence followed by `elem`.

    Definition Classes
      GenSeqLike

14. #### def :+[B >: A, That](elem: B)(implicit bf: CanBuildFrom[Repr, B, That]): That

    A copy of this mutable indexed sequence with an element appended.

    A copy of this mutable indexed sequence with an element appended.

    B

      the element type of the returned mutable indexed sequence.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    elem

      the appended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` consisting of all elements of this mutable indexed sequence followed by `elem`.

    Definition Classes
      SeqLike → GenSeqLike

15. #### def :\[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this mutable indexed sequence and a start value, going right to left.

    Applies a binary operator to all elements of this mutable indexed sequence and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this mutable indexed sequence, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this mutable indexed sequence.

    Definition Classes
      TraversableOnce → GenTraversableOnce

16. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

17. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

18. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this mutable indexed sequence to a string builder.

    Appends all elements of this mutable indexed sequence to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this mutable indexed sequence without any separator string.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> val h = a.addString(b)
             b: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

19. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this mutable indexed sequence to a string builder using a separator string.

    Appends all elements of this mutable indexed sequence to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this mutable indexed sequence, separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, ", ")
             res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

20. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all elements of this mutable indexed sequence to a string builder using start, end, and separator strings.

    Appends all elements of this mutable indexed sequence to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this mutable indexed sequence are separated by the string `sep`.

    Example:

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = new StringBuilder()
             b: StringBuilder =

             scala> a.addString(b, "LinkedList(", ", ", ")")
             res1: StringBuilder = LinkedList(1, 2, 3, 4)

    b

      the string builder to which elements are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

21. #### def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

22. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

23. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this mutable indexed sequence should be compared

    returns

      `true`, if this mutable indexed sequence can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

24. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

25. #### abstract def collect[B](pf: PartialFunction[A, B]): IndexedSeq[B]

    [use case] Builds a new collection by applying a partial function to all elements of this mutable indexed sequence on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this mutable indexed sequence on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the mutable indexed sequence.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

26. #### def collect[B, That](pf: PartialFunction[A, B])(implicit bf: CanBuildFrom[Repr, B, That]): That

    Builds a new collection by applying a partial function to all elements of this mutable indexed sequence on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this mutable indexed sequence on which the function is defined.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the mutable indexed sequence.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

27. #### def collectFirst[B](pf: PartialFunction[A, B]): Option[B]

    Finds the first element of the mutable indexed sequence for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the mutable indexed sequence for which the given partial function is defined, and applies the partial function to it.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

28. #### def combinations(n: Int): Iterator[Repr]

    Iterates over combinations.

    Iterates over combinations.

    returns

      An Iterator which traverses the possible n-element combinations of this mutable indexed sequence.

    Definition Classes
      SeqLike
    Example:

    1. `"abbbc".combinations(2) = Iterator(ab, ac, bb, bc)`

29. #### def contains(elem: Any): Boolean

    Tests whether this mutable indexed sequence contains a given value as an element.

    Tests whether this mutable indexed sequence contains a given value as an element.

    elem

      the element to test.

    returns

      `true` if this mutable indexed sequence has an element that is is equal (wrt `==`) to `elem`, `false` otherwise.

    Definition Classes
      SeqLike

30. #### def containsSlice[B](that: GenSeq[B]): Boolean

    Tests whether this mutable indexed sequence contains a given sequence as a slice.

    Tests whether this mutable indexed sequence contains a given sequence as a slice.

    that

      the sequence to test

    returns

      `true` if this mutable indexed sequence contains a slice with the same elements as `that`, otherwise `false`.

    Definition Classes
      SeqLike

31. #### abstract def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this mutable indexed sequence to an array.

    [use case]

    Copies elements of this mutable indexed sequence to an array. Fills the given array `xs` with at most `len` elements of this mutable indexed sequence, starting at position `start`. Copying will stop once either the end of the current mutable indexed sequence is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      TraversableLike

32. #### def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

    Copies elements of this mutable indexed sequence to an array.

    Copies elements of this mutable indexed sequence to an array. Fills the given array `xs` with at most `len` elements of this mutable indexed sequence, starting at position `start`. Copying will stop once either the end of the current mutable indexed sequence is reached, or the end of the array is reached, or `len` elements have been copied.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

33. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this mutable indexed sequence to an array.

    [use case]

    Copies values of this mutable indexed sequence to an array. Fills the given array `xs` with values of this mutable indexed sequence. Copying will stop once either the end of the current mutable indexed sequence is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

34. #### def copyToArray[B >: A](xs: Array[B]): Unit

    Copies values of this mutable indexed sequence to an array.

    Copies values of this mutable indexed sequence to an array. Fills the given array `xs` with values of this mutable indexed sequence. Copying will stop once either the end of the current mutable indexed sequence is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce

35. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this mutable indexed sequence to an array.

    [use case]

    Copies values of this mutable indexed sequence to an array. Fills the given array `xs` with values of this mutable indexed sequence, beginning at index `start`. Copying will stop once either the end of the current mutable indexed sequence is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

36. #### def copyToArray[B >: A](xs: Array[B], start: Int): Unit

    Copies values of this mutable indexed sequence to an array.

    Copies values of this mutable indexed sequence to an array. Fills the given array `xs` with values of this mutable indexed sequence, beginning at index `start`. Copying will stop once either the end of the current mutable indexed sequence is reached, or the end of the array is reached.

    B

      the type of the elements of the array.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce

37. #### def copyToBuffer[B >: A](dest: Buffer[B]): Unit

    Copies all elements of this mutable indexed sequence to a buffer.

    Copies all elements of this mutable indexed sequence to a buffer.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

38. #### def corresponds[B](that: GenSeq[B])(p: (A, B) ⇒ Boolean): Boolean

    Tests whether every element of this mutable indexed sequence relates to the corresponding element of another sequence by satisfying a test predicate.

    Tests whether every element of this mutable indexed sequence relates to the corresponding element of another sequence by satisfying a test predicate.

    B

      the type of the elements of `that`

    that

      the other sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this mutable indexed sequence and `y` of `that`, otherwise `false`.

    Definition Classes
      SeqLike → GenSeqLike

39. #### def count(p: (A) ⇒ Boolean): Int

    Counts the number of elements in the mutable indexed sequence which satisfy a predicate.

    Counts the number of elements in the mutable indexed sequence which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

40. #### abstract def diff(that: Seq[A]): IndexedSeq[A]

    [use case] Computes the multiset difference between this mutable indexed sequence and another sequence.

    [use case]

    Computes the multiset difference between this mutable indexed sequence and another sequence.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this mutable indexed sequence except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike

41. #### def diff[B >: A](that: GenSeq[B]): Repr

    Computes the multiset difference between this mutable indexed sequence and another sequence.

    Computes the multiset difference between this mutable indexed sequence and another sequence.

    B

      the element type of the returned mutable indexed sequence.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this mutable indexed sequence except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      SeqLike → GenSeqLike

42. #### def distinct: Repr

    Builds a new mutable indexed sequence from this mutable indexed sequence without any duplicate elements.

    Builds a new mutable indexed sequence from this mutable indexed sequence without any duplicate elements.

    returns

      A new mutable indexed sequence which contains the first occurrence of every element of this mutable indexed sequence.

    Definition Classes
      SeqLike → GenSeqLike

43. #### def drop(n: Int): Repr

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this mutable indexed sequence.

    returns

      a mutable indexed sequence consisting of all elements of this mutable indexed sequence except the first `n` ones, or else the empty mutable indexed sequence, if this mutable indexed sequence has less than `n` elements.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

44. #### def dropRight(n: Int): Repr

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a mutable indexed sequence consisting of all elements of this mutable indexed sequence except the last `n` ones, or else the empty mutable indexed sequence, if this mutable indexed sequence has less than `n` elements.

    Definition Classes
      IndexedSeqOptimized → IterableLike

45. #### def dropWhile(p: (A) ⇒ Boolean): Repr

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    p

      The predicate used to test elements.

    returns

      the longest suffix of this mutable indexed sequence whose first element does not satisfy the predicate `p`.

    Definition Classes
      IndexedSeqOptimized → TraversableLike → GenTraversableLike

46. #### def endsWith[B](that: GenSeq[B]): Boolean

    Tests whether this mutable indexed sequence ends with the given sequence.

    Tests whether this mutable indexed sequence ends with the given sequence.

    that

      the sequence to test

    returns

      `true` if this mutable indexed sequence has `that` as a suffix, `false` otherwise.

    Definition Classes
      IndexedSeqOptimized → SeqLike → GenSeqLike

47. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

48. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → AnyRef → Any

49. #### def exists(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this mutable indexed sequence.

    Tests whether a predicate holds for some of the elements of this mutable indexed sequence.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for some of the elements of this mutable indexed sequence, otherwise `false`.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

50. #### def filter(p: (A) ⇒ Boolean): Repr

    Selects all elements of this mutable indexed sequence which satisfy a predicate.

    Selects all elements of this mutable indexed sequence which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new mutable indexed sequence consisting of all elements of this mutable indexed sequence that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

51. #### def filterNot(p: (A) ⇒ Boolean): Repr

    Selects all elements of this mutable indexed sequence which do not satisfy a predicate.

    Selects all elements of this mutable indexed sequence which do not satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new mutable indexed sequence consisting of all elements of this mutable indexed sequence that do not satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

52. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

53. #### def find(p: (A) ⇒ Boolean): Option[A]

    Finds the first element of the mutable indexed sequence satisfying a predicate, if any.

    Finds the first element of the mutable indexed sequence satisfying a predicate, if any.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the mutable indexed sequence that satisfies `p`, or `None` if none exists.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

54. #### abstract def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): IndexedSeq[B]

    [use case] Builds a new collection by applying a function to all elements of this mutable indexed sequence and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this mutable indexed sequence and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this mutable indexed sequence and concatenating the results.

    Definition Classes
      GenTraversableLike

55. #### def flatMap[B, That](f: (A) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

    Builds a new collection by applying a function to all elements of this mutable indexed sequence and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this mutable indexed sequence and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of mutable indexed sequence. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this mutable indexed sequence and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

56. #### def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this mutable indexed sequence using the specified associative binary operator.

    Folds the elements of this mutable indexed sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

57. #### def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this mutable indexed sequence, going left to right.

    Applies a binary operator to a start value and all elements of this mutable indexed sequence, going left to right.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this mutable indexed sequence, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this mutable indexed sequence.

    Definition Classes
      IndexedSeqOptimized → TraversableOnce → GenTraversableOnce

58. #### def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this mutable indexed sequence and a start value, going right to left.

    Applies a binary operator to all elements of this mutable indexed sequence and a start value, going right to left.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this mutable indexed sequence, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this mutable indexed sequence.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableOnce → GenTraversableOnce

59. #### def forall(p: (A) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this mutable indexed sequence.

    Tests whether a predicate holds for all elements of this mutable indexed sequence.

    p

      the predicate used to test elements.

    returns

      `true` if the given predicate `p` holds for all elements of this mutable indexed sequence, otherwise `false`.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

60. #### abstract def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this mutable indexed sequence.

    [use case]

    Applies a function `f` to all elements of this mutable indexed sequence.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IterableLike

61. #### def foreach[U](f: (A) ⇒ U): Unit

    Applies a function `f` to all elements of this mutable indexed sequence.

    Applies a function `f` to all elements of this mutable indexed sequence.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    U

      the type parameter describing the result of function `f`. This result will always be ignored. Typically `U` is `Unit`, but this is not necessary.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic

62. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

63. #### def groupBy[K](f: (A) ⇒ K): Map[K, Repr]

    Partitions this mutable indexed sequence into a map of mutable indexed sequences according to some discriminator function.

    Partitions this mutable indexed sequence into a map of mutable indexed sequences according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new mutable indexed sequence.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to mutable indexed sequences such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a mutable indexed sequence of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

64. #### def grouped(size: Int): Iterator[Repr]

    Partitions elements in fixed size mutable indexed sequences.

    Partitions elements in fixed size mutable indexed sequences.

    size

      the number of elements per group

    returns

      An iterator producing mutable indexed sequences of size `size`, except the last will be truncated if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      Iterator#grouped

65. #### def hasDefiniteSize: Boolean

    Tests whether this mutable indexed sequence is known to have a finite size.

    Tests whether this mutable indexed sequence is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

66. #### def hashCode(): Int

    Hashcodes for IndexedSeq produce a value from the hashcodes of all the elements of the mutable indexed sequence.

    Hashcodes for IndexedSeq produce a value from the hashcodes of all the elements of the mutable indexed sequence.

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → AnyRef → Any

67. #### def head: A

    Selects the first element of this mutable indexed sequence.

    Selects the first element of this mutable indexed sequence.

    returns

      the first element of this mutable indexed sequence.

    Definition Classes
      IndexedSeqOptimized → IterableLike → GenIterableLike → TraversableLike → GenTraversableLike
    Exceptions thrown
      `NoSuchElementException`

      if the mutable indexed sequence is empty.

68. #### def headOption: Option[A]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this mutable indexed sequence if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

69. #### abstract def indexOf(elem: A, from: Int): Int

    [use case] Finds index of first occurrence of some value in this mutable indexed sequence after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this mutable indexed sequence after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this mutable indexed sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

70. #### def indexOf[B >: A](elem: B, from: Int): Int

    Finds index of first occurrence of some value in this mutable indexed sequence after or at some start index.

    Finds index of first occurrence of some value in this mutable indexed sequence after or at some start index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this mutable indexed sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

71. #### abstract def indexOf(elem: A): Int

    [use case] Finds index of first occurrence of some value in this mutable indexed sequence.

    [use case]

    Finds index of first occurrence of some value in this mutable indexed sequence.

    elem

      the element value to search for.

    returns

      the index of the first element of this mutable indexed sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

72. #### def indexOf[B >: A](elem: B): Int

    Finds index of first occurrence of some value in this mutable indexed sequence.

    Finds index of first occurrence of some value in this mutable indexed sequence.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the first element of this mutable indexed sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

73. #### def indexOfSlice[B >: A](that: GenSeq[B], from: Int): Int

    Finds first index after or at a start index where this mutable indexed sequence contains a given sequence as a slice.

    Finds first index after or at a start index where this mutable indexed sequence contains a given sequence as a slice.

    that

      the sequence to test

    from

      the start index

    returns

      the first index `>= from` such that the elements of this mutable indexed sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

74. #### def indexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds first index where this mutable indexed sequence contains a given sequence as a slice.

    Finds first index where this mutable indexed sequence contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the first index such that the elements of this mutable indexed sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

75. #### def indexWhere(p: (A) ⇒ Boolean, from: Int): Int

    Finds index of the first element satisfying some predicate after or at some start index.

    Finds index of the first element satisfying some predicate after or at some start index.

    p

      the predicate used to test elements.

    from

      the start index

    returns

      the index `>= from` of the first element of this mutable indexed sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      IndexedSeqOptimized → SeqLike → GenSeqLike

76. #### def indexWhere(p: (A) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this mutable indexed sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

77. #### def indices: Range

    Produces the range of all indices of this sequence.

    Produces the range of all indices of this sequence.

    returns

      a `Range` value from `0` to one less than the length of this mutable indexed sequence.

    Definition Classes
      SeqLike

78. #### def init: Repr

    Selects all elements except the last.

    Selects all elements except the last.

    returns

      a mutable indexed sequence consisting of all elements of this mutable indexed sequence except the last one.

    Definition Classes
      IndexedSeqOptimized → TraversableLike
    Exceptions thrown
      `UnsupportedOperationException`

      if the mutable indexed sequence is empty.

79. #### def inits: Iterator[Repr]

    Iterates over the inits of this mutable indexed sequence.

    Iterates over the inits of this mutable indexed sequence. The first value will be this mutable indexed sequence and the final one will be an empty mutable indexed sequence, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this mutable indexed sequence

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

80. #### abstract def intersect(that: Seq[A]): IndexedSeq[A]

    [use case] Computes the multiset intersection between this mutable indexed sequence and another sequence.

    [use case]

    Computes the multiset intersection between this mutable indexed sequence and another sequence.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this mutable indexed sequence which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike

81. #### def intersect[B >: A](that: GenSeq[B]): Repr

    Computes the multiset intersection between this mutable indexed sequence and another sequence.

    Computes the multiset intersection between this mutable indexed sequence and another sequence.

    B

      the element type of the returned mutable indexed sequence.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this mutable indexed sequence which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      SeqLike → GenSeqLike

82. #### def isDefinedAt(idx: Int): Boolean

    Tests whether this mutable indexed sequence contains given index.

    Tests whether this mutable indexed sequence contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    idx

      the index to test

    returns

      `true` if this mutable indexed sequence contains an element at position `idx`, `false` otherwise.

    Definition Classes
      GenSeqLike

83. #### def isEmpty: Boolean

    Tests whether the mutable indexed sequence is empty.

    Tests whether the mutable indexed sequence is empty.

    returns

      `true` if the mutable indexed sequence contains no elements, `false` otherwise.

    Definition Classes
      IndexedSeqOptimized → IterableLike → GenIterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

84. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

85. #### final def isTraversableAgain: Boolean

    Tests whether this mutable indexed sequence can be repeatedly traversed.

    Tests whether this mutable indexed sequence can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

86. #### def iterator: Iterator[A]

    Creates a new iterator over all elements contained in this iterable object.

    Creates a new iterator over all elements contained in this iterable object.

    returns

      the new iterator

    Definition Classes
      IndexedSeqLike → IterableLike → GenIterableLike

87. #### def last: A

    Selects the last element.

    Selects the last element.

    returns

      The last element of this mutable indexed sequence.

    Definition Classes
      IndexedSeqOptimized → TraversableLike
    Exceptions thrown
      NoSuchElementException

      If the mutable indexed sequence is empty.

88. #### abstract def lastIndexOf(elem: A, end: Int): Int

    [use case] Finds index of last occurrence of some value in this mutable indexed sequence before or at a given end index.

    [use case]

    Finds index of last occurrence of some value in this mutable indexed sequence before or at a given end index.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this mutable indexed sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

89. #### def lastIndexOf[B >: A](elem: B, end: Int): Int

    Finds index of last occurrence of some value in this mutable indexed sequence before or at a given end index.

    Finds index of last occurrence of some value in this mutable indexed sequence before or at a given end index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this mutable indexed sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

90. #### abstract def lastIndexOf(elem: A): Int

    [use case] Finds index of last occurrence of some value in this mutable indexed sequence.

    [use case]

    Finds index of last occurrence of some value in this mutable indexed sequence.

    elem

      the element value to search for.

    returns

      the index of the last element of this mutable indexed sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

91. #### def lastIndexOf[B >: A](elem: B): Int

    Finds index of last occurrence of some value in this mutable indexed sequence.

    Finds index of last occurrence of some value in this mutable indexed sequence.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the last element of this mutable indexed sequence that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

92. #### def lastIndexOfSlice[B >: A](that: GenSeq[B], end: Int): Int

    Finds last index before or at a given end index where this mutable indexed sequence contains a given sequence as a slice.

    Finds last index before or at a given end index where this mutable indexed sequence contains a given sequence as a slice.

    that

      the sequence to test

    end

      the end index

    returns

      the last index `<= end` such that the elements of this mutable indexed sequence starting at this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

93. #### def lastIndexOfSlice[B >: A](that: GenSeq[B]): Int

    Finds last index where this mutable indexed sequence contains a given sequence as a slice.

    Finds last index where this mutable indexed sequence contains a given sequence as a slice.

    that

      the sequence to test

    returns

      the last index such that the elements of this mutable indexed sequence starting a this index match the elements of sequence `that`, or `-1` of no such subsequence exists.

    Definition Classes
      SeqLike

94. #### def lastIndexWhere(p: (A) ⇒ Boolean, end: Int): Int

    Finds index of last element satisfying some predicate before or at given end index.

    Finds index of last element satisfying some predicate before or at given end index.

    p

      the predicate used to test elements.

    returns

      the index `<= end` of the last element of this mutable indexed sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      IndexedSeqOptimized → SeqLike → GenSeqLike

95. #### def lastIndexWhere(p: (A) ⇒ Boolean): Int

    Finds index of last element satisfying some predicate.

    Finds index of last element satisfying some predicate.

    p

      the predicate used to test elements.

    returns

      the index of the last element of this mutable indexed sequence that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

96. #### def lastOption: Option[A]

    Optionally selects the last element.

    Optionally selects the last element.

    returns

      the last element of this mutable indexed sequence$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TraversableLike

97. #### def lengthCompare(len: Int): Int

    Compares the length of this mutable indexed sequence to a test value.

    Compares the length of this mutable indexed sequence to a test value.

    len

      the test value that gets compared with the length.

    returns

      A value `x` where

                 x <  0       if this.length <  len
                 x == 0       if this.length == len
                 x >  0       if this.length >  len

      The method as implemented here does not call `length` directly; its running time is `O(length min len)` instead of `O(length)`. The method should be overwritten if computing `length` is cheap.

    Definition Classes
      IndexedSeqOptimized → SeqLike

98. #### abstract def map[B](f: (A) ⇒ B): IndexedSeq[B]

    [use case] Builds a new collection by applying a function to all elements of this mutable indexed sequence.

    [use case]

    Builds a new collection by applying a function to all elements of this mutable indexed sequence.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this mutable indexed sequence and collecting the results.

    Definition Classes
      GenTraversableLike

99. #### def map[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[Repr, B, That]): That

    Builds a new collection by applying a function to all elements of this mutable indexed sequence.

    Builds a new collection by applying a function to all elements of this mutable indexed sequence.

    B

      the element type of the returned collection.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this mutable indexed sequence and collecting the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic

100. #### abstract def max: A

     [use case] Finds the largest element.

     [use case]

     Finds the largest element.

     returns

       the largest element of this mutable indexed sequence with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

101. #### def max[B >: A](implicit cmp: Ordering[B]): A

     Finds the largest element.

     Finds the largest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the largest element of this mutable indexed sequence with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

102. #### def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

103. #### abstract def min: A

     [use case] Finds the smallest element.

     [use case]

     Finds the smallest element.

     returns

       the smallest element of this mutable indexed sequence with respect to the ordering `cmp`.

     Definition Classes
       GenTraversableOnce

104. #### def min[B >: A](implicit cmp: Ordering[B]): A

     Finds the smallest element.

     Finds the smallest element.

     B

       The type over which the ordering is defined.

     cmp

       An ordering to be used for comparing elements.

     returns

       the smallest element of this mutable indexed sequence with respect to the ordering `cmp`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

105. #### def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

     Definition Classes
       TraversableOnce → GenTraversableOnce

106. #### def mkString: String

     Displays all elements of this mutable indexed sequence in a string.

     Displays all elements of this mutable indexed sequence in a string.

     returns

       a string representation of this mutable indexed sequence. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this mutable indexed sequence follow each other without any separator string.

     Definition Classes
       TraversableOnce → GenTraversableOnce

107. #### def mkString(sep: String): String

     Displays all elements of this mutable indexed sequence in a string using a separator string.

     Displays all elements of this mutable indexed sequence in a string using a separator string.

     sep

       the separator string.

     returns

       a string representation of this mutable indexed sequence. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this mutable indexed sequence are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("|") = "1|2|3"`

108. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this mutable indexed sequence in a string using start, end, and separator strings.

     Displays all elements of this mutable indexed sequence in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this mutable indexed sequence. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this mutable indexed sequence are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

109. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

110. #### def nonEmpty: Boolean

     Tests whether the mutable indexed sequence is not empty.

     Tests whether the mutable indexed sequence is not empty.

     returns

       `true` if the mutable indexed sequence contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

111. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

112. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

113. #### abstract def padTo(len: Int, elem: A): IndexedSeq[A]

     [use case] A copy of this mutable indexed sequence with an element value appended until a given target length is reached.

     [use case]

     A copy of this mutable indexed sequence with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new collection of type `That` consisting of all elements of this mutable indexed sequence followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       GenSeqLike

114. #### def padTo[B >: A, That](len: Int, elem: B)(implicit bf: CanBuildFrom[Repr, B, That]): That

     A copy of this mutable indexed sequence with an element value appended until a given target length is reached.

     A copy of this mutable indexed sequence with an element value appended until a given target length is reached.

     B

       the element type of the returned mutable indexed sequence.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     len

       the target length

     elem

       the padding value

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` consisting of all elements of this mutable indexed sequence followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       SeqLike → GenSeqLike

115. #### def par: ParSeq[A]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

116. #### def parCombiner: Combiner[A, ParSeq[A]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       SeqLike → TraversableLike → Parallelizable

117. #### def partition(p: (A) ⇒ Boolean): (Repr, Repr)

     Partitions this mutable indexed sequence in two mutable indexed sequences according to a predicate.

     Partitions this mutable indexed sequence in two mutable indexed sequences according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of mutable indexed sequences: the first mutable indexed sequence consists of all elements that satisfy the predicate `p` and the second mutable indexed sequence consists of all elements that don't. The relative order of the elements in the resulting mutable indexed sequences is the same as in the original mutable indexed sequence.

     Definition Classes
       TraversableLike → GenTraversableLike

118. #### abstract def patch(from: Int, that: GenSeq[A], replaced: Int): IndexedSeq[A]

     [use case] Produces a new mutable indexed sequence where a slice of elements in this mutable indexed sequence is replaced by another sequence.

     [use case]

     Produces a new mutable indexed sequence where a slice of elements in this mutable indexed sequence is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original mutable indexed sequence

     returns

       a new mutable indexed sequence consisting of all elements of this mutable indexed sequence except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       GenSeqLike

119. #### def patch[B >: A, That](from: Int, patch: GenSeq[B], replaced: Int)(implicit bf: CanBuildFrom[Repr, B, That]): That

     Produces a new mutable indexed sequence where a slice of elements in this mutable indexed sequence is replaced by another sequence.

     Produces a new mutable indexed sequence where a slice of elements in this mutable indexed sequence is replaced by another sequence.

     B

       the element type of the returned mutable indexed sequence.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     from

       the index of the first replaced element

     patch

       the replacement sequence

     replaced

       the number of elements to drop in the original mutable indexed sequence

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new mutable indexed sequence consisting of all elements of this mutable indexed sequence except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       SeqLike → GenSeqLike

120. #### def permutations: Iterator[Repr]

     Iterates over distinct permutations.

     Iterates over distinct permutations.

     returns

       An Iterator which traverses the distinct permutations of this mutable indexed sequence.

     Definition Classes
       SeqLike
     Example:

     1. `"abb".permutations = Iterator(abb, bab, bba)`

121. #### def prefixLength(p: (A) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this mutable indexed sequence such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

122. #### abstract def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this mutable indexed sequence with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

123. #### def product[B >: A](implicit num: Numeric[B]): B

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     B

       the result type of the `*` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this mutable indexed sequence with respect to the `*` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

124. #### def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this mutable indexed sequence using the specified associative binary operator.

     Reduces the elements of this mutable indexed sequence using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the mutable indexed sequence is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this mutable indexed sequence is empty.

125. #### def reduceLeft[B >: A](op: (B, A) ⇒ B): B

     Definition Classes
       IndexedSeqOptimized → TraversableOnce

126. #### def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this mutable indexed sequence, going left to right.

     Optionally applies a binary operator to all elements of this mutable indexed sequence, going left to right.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this mutable indexed sequence is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

127. #### def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this mutable indexed sequence, if any, using the specified associative binary operator.

     Reduces the elements of this mutable indexed sequence, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

128. #### def reduceRight[B >: A](op: (A, B) ⇒ B): B

     Applies a binary operator to all elements of this mutable indexed sequence, going right to left.

     Applies a binary operator to all elements of this mutable indexed sequence, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this mutable indexed sequence, going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this mutable indexed sequence.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this mutable indexed sequence is empty.

129. #### def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this mutable indexed sequence, going right to left.

     Optionally applies a binary operator to all elements of this mutable indexed sequence, going right to left.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this mutable indexed sequence is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

130. #### def repr: Repr

     The collection of type mutable indexed sequence underlying this `TraversableLike` object.

     The collection of type mutable indexed sequence underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

131. #### def reverse: Repr

     Returns new mutable indexed sequence wih elements in reversed order.

     Returns new mutable indexed sequence wih elements in reversed order.

     returns

       A new mutable indexed sequence with all elements of this mutable indexed sequence in reversed order.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

132. #### def reverseIterator: Iterator[A]

     An iterator yielding elements in reversed order.

     An iterator yielding elements in reversed order.

     Note: `xs.reverseIterator` is the same as `xs.reverse.iterator` but might be more efficient.

     returns

       an iterator yielding the elements of this mutable indexed sequence in reversed order

     Definition Classes
       IndexedSeqOptimized → SeqLike

133. #### abstract def reverseMap[B](f: (A) ⇒ B): IndexedSeq[B]

     [use case] Builds a new collection by applying a function to all elements of this mutable indexed sequence and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this mutable indexed sequence and collecting the results in reversed order.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this mutable indexed sequence and collecting the results in reversed order.

       Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     Definition Classes
       GenSeqLike

134. #### def reverseMap[B, That](f: (A) ⇒ B)(implicit bf: CanBuildFrom[Repr, B, That]): That

     Builds a new collection by applying a function to all elements of this mutable indexed sequence and collecting the results in reversed order.

     Builds a new collection by applying a function to all elements of this mutable indexed sequence and collecting the results in reversed order.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     B

       the element type of the returned collection.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this mutable indexed sequence and collecting the results in reversed order.

     Definition Classes
       SeqLike → GenSeqLike

135. #### def reversed: List[A]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

136. #### abstract def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this mutable indexed sequence.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this mutable indexed sequence.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

137. #### def sameElements[B >: A](that: GenIterable[B]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this mutable indexed sequence.

     Checks if the other iterable collection contains the same elements in the same order as this mutable indexed sequence.

     B

       the type of the elements of collection `that`.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike

138. #### def scan[B >: A, That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[Repr, B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new mutable indexed sequence containing the prefix scan of the elements in this mutable indexed sequence

     Definition Classes
       TraversableLike → GenTraversableLike

139. #### def scanLeft[B, That](z: B)(op: (B, A) ⇒ B)(implicit bf: CanBuildFrom[Repr, B, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

140. #### def scanRight[B, That](z: B)(op: (A, B) ⇒ B)(implicit bf: CanBuildFrom[Repr, B, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

141. #### def segmentLength(p: (A) ⇒ Boolean, from: Int): Int

     Computes length of longest segment whose elements all satisfy some predicate.

     Computes length of longest segment whose elements all satisfy some predicate.

     p

       the predicate used to test elements.

     from

       the index where the search starts.

     returns

       the length of the longest segment of this mutable indexed sequence starting from index `from` such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

142. #### def size: Int

     The size of this mutable indexed sequence, equivalent to `length`.

     The size of this mutable indexed sequence, equivalent to `length`.

     returns

       the number of elements in this mutable indexed sequence.

     Definition Classes
       SeqLike → GenTraversableLike → TraversableOnce → GenTraversableOnce

143. #### def slice(from: Int, until: Int): Repr

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     from

       the lowest index to include from this mutable indexed sequence.

     until

       the highest index to EXCLUDE from this mutable indexed sequence.

     returns

       a mutable indexed sequence containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this mutable indexed sequence.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

144. #### def sliding[B >: A](size: Int, step: Int): Iterator[Repr]

     Definition Classes
       IterableLike

145. #### def sliding[B >: A](size: Int): Iterator[Repr]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     returns

       An iterator producing mutable indexed sequences of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       Iterator#sliding

146. #### def sortBy[B](f: (A) ⇒ B)(implicit ord: Ordering[B]): Repr

     Sorts this IndexedSeq according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     Sorts this IndexedSeq according to the Ordering which results from transforming an implicitly given Ordering with a transformation function.

     B

       the target type of the transformation `f`, and the type where the ordering `ord` is defined.

     f

       the transformation function mapping elements to some other domain `B`.

     ord

       the ordering assumed on domain `B`.

     returns

       a mutable indexed sequence consisting of the elements of this mutable indexed sequence sorted according to the ordering where `x < y` if `ord.lt(f(x), f(y))`.

     Definition Classes
       SeqLike
     Example:

     1.        val words = "The quick brown fox jumped over the lazy dog".split(' ')
               // this works because scala.Ordering will implicitly provide an Ordering[Tuple2[Int, Char]]
               words.sortBy(x => (x.length, x.head))
               res0: Array[String] = Array(The, dog, fox, the, lazy, over, brown, quick, jumped)

     See also

       scala.math.Ordering

147. #### def sortWith(lt: (A, A) ⇒ Boolean): Repr

     Sorts this mutable indexed sequence according to a comparison function.

     Sorts this mutable indexed sequence according to a comparison function.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     lt

       the comparison function which tests whether its first argument precedes its second argument in the desired ordering.

     returns

       a mutable indexed sequence consisting of the elements of this mutable indexed sequence sorted according to the comparison function `lt`.

     Definition Classes
       SeqLike
     Example:

     1.        List("Steve", "Tom", "John", "Bob").sortWith(_.compareTo(_) < 0) =
               List("Bob", "John", "Steve", "Tom")

148. #### def sorted[B >: A](implicit ord: Ordering[B]): Repr

     Sorts this mutable indexed sequence according to an Ordering.

     Sorts this mutable indexed sequence according to an Ordering.

     The sort is stable. That is, elements that are equal wrt `lt` appear in the same order in the sorted sequence as in the original.

     ord

       the ordering to be used to compare elements.

     returns

       a mutable indexed sequence consisting of the elements of this mutable indexed sequence sorted according to the ordering `ord`.

     Definition Classes
       SeqLike
     See also

       scala.math.Ordering

149. #### def span(p: (A) ⇒ Boolean): (Repr, Repr)

     Splits this mutable indexed sequence into a prefix/suffix pair according to a predicate.

     Splits this mutable indexed sequence into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     p

       the test predicate

     returns

       a pair consisting of the longest prefix of this mutable indexed sequence whose elements all satisfy `p`, and the rest of this mutable indexed sequence.

     Definition Classes
       IndexedSeqOptimized → TraversableLike → GenTraversableLike

150. #### def splitAt(n: Int): (Repr, Repr)

     Splits this mutable indexed sequence into two at a given position.

     Splits this mutable indexed sequence into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of mutable indexed sequences consisting of the first `n` elements of this mutable indexed sequence, and the other elements.

     Definition Classes
       IndexedSeqOptimized → TraversableLike → GenTraversableLike

151. #### def startsWith[B](that: GenSeq[B], offset: Int): Boolean

     Tests whether this mutable indexed sequence contains the given sequence at a given index.

     Tests whether this mutable indexed sequence contains the given sequence at a given index.

     If the both the receiver object, `this` and the argument, `that` are infinite sequences this method may not terminate.

     that

       the sequence to test

     offset

       the index where the sequence is searched.

     returns

       `true` if the sequence `that` is contained in this mutable indexed sequence at index `offset`, otherwise `false`.

     Definition Classes
       IndexedSeqOptimized → SeqLike → GenSeqLike

152. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this mutable indexed sequence starts with the given sequence.

     Tests whether this mutable indexed sequence starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

153. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this mutable indexed sequence. By default the string prefix is the simple name of the collection class mutable indexed sequence.

     Definition Classes
       TraversableLike → GenTraversableLike

154. #### abstract def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this mutable indexed sequence with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

155. #### def sum[B >: A](implicit num: Numeric[B]): B

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     B

       the result type of the `+` operator.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this mutable indexed sequence with respect to the `+` operator in `num`.

     Definition Classes
       TraversableOnce → GenTraversableOnce

156. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

157. #### def tail: Repr

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a mutable indexed sequence consisting of all elements of this mutable indexed sequence except the first one.

     Definition Classes
       IndexedSeqOptimized → TraversableLike → GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the mutable indexed sequence is empty.

158. #### def tails: Iterator[Repr]

     Iterates over the tails of this mutable indexed sequence.

     Iterates over the tails of this mutable indexed sequence. The first value will be this mutable indexed sequence and the final one will be an empty mutable indexed sequence, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this mutable indexed sequence

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

159. #### def take(n: Int): Repr

     Selects first n elements.

     Selects first n elements.

     n

       Tt number of elements to take from this mutable indexed sequence.

     returns

       a mutable indexed sequence consisting only of the first `n` elements of this mutable indexed sequence, or else the whole mutable indexed sequence, if it has less than `n` elements.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

160. #### def takeRight(n: Int): Repr

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a mutable indexed sequence consisting only of the last `n` elements of this mutable indexed sequence, or else the whole mutable indexed sequence, if it has less than `n` elements.

     Definition Classes
       IndexedSeqOptimized → IterableLike

161. #### def takeWhile(p: (A) ⇒ Boolean): Repr

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     p

       The predicate used to test elements.

     returns

       the longest prefix of this mutable indexed sequence whose elements all satisfy the predicate `p`.

     Definition Classes
       IndexedSeqOptimized → IterableLike → TraversableLike → GenTraversableLike

162. #### def thisCollection: IndexedSeq[A]

     The underlying collection seen as an instance of `IndexedSeq`.

     The underlying collection seen as an instance of `IndexedSeq`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IndexedSeqLike → IndexedSeqLike → SeqLike → IterableLike → TraversableLike

163. #### abstract def toArray: Array[A]

     [use case] Converts this mutable indexed sequence to an array.

     [use case]

     Converts this mutable indexed sequence to an array.

     returns

       an array containing all elements of this mutable indexed sequence.

     Definition Classes
       GenTraversableOnce

164. #### def toArray[B >: A](implicit arg0: ClassManifest[B]): Array[B]

     Converts this mutable indexed sequence to an array.

     Converts this mutable indexed sequence to an array.

     B

       the type of the elements of the array. A `ClassManifest` for this type must be available.

     returns

       an array containing all elements of this mutable indexed sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

165. #### def toBuffer[A1 >: A]: Buffer[A1]

     Overridden for efficiency

     Overridden for efficiency

     returns

       a buffer containing all elements of this mutable indexed sequence.

     Definition Classes
       IndexedSeqLike → TraversableOnce → GenTraversableOnce

166. #### def toCollection(repr: Repr): IndexedSeq[A]

     A conversion from collections of type `Repr` to `IndexedSeq` objects.

     A conversion from collections of type `Repr` to `IndexedSeq` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IndexedSeqLike → IndexedSeqLike → SeqLike → IterableLike → TraversableLike

167. #### def toIndexedSeq[B >: A]: IndexedSeq[B]

     Converts this mutable indexed sequence to an indexed sequence.

     Converts this mutable indexed sequence to an indexed sequence.

     returns

       an indexed sequence containing all elements of this mutable indexed sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

168. #### def toIterable: Iterable[A]

     Converts this mutable indexed sequence to an iterable collection.

     Converts this mutable indexed sequence to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     returns

       an `Iterable` containing all elements of this mutable indexed sequence.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

169. #### def toIterator: Iterator[A]

     Returns an Iterator over the elements in this mutable indexed sequence.

     Returns an Iterator over the elements in this mutable indexed sequence. Will return the same Iterator if this instance is already an Iterator.

     returns

       an Iterator containing all elements of this mutable indexed sequence.

     Definition Classes
       TraversableLike → GenTraversableOnce

170. #### def toList: List[A]

     Converts this mutable indexed sequence to a list.

     Converts this mutable indexed sequence to a list.

     returns

       a list containing all elements of this mutable indexed sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

171. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this mutable indexed sequence to a map.

     [use case]

     Converts this mutable indexed sequence to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this mutable indexed sequence.

     Definition Classes
       GenTraversableOnce

172. #### def toMap[T, U](implicit ev: <:<[A, (T, U)]): Map[T, U]

     Converts this mutable indexed sequence to a map.

     Converts this mutable indexed sequence to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     returns

       a map containing all elements of this mutable indexed sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

173. #### def toSeq: Seq[A]

     Converts this mutable indexed sequence to a sequence.

     Converts this mutable indexed sequence to a sequence.

     Overridden for efficiency.

     returns

       a sequence containing all elements of this mutable indexed sequence.

     Definition Classes
       SeqLike → GenSeqLike → TraversableOnce → GenTraversableOnce

174. #### def toSet[B >: A]: Set[B]

     Converts this mutable indexed sequence to a set.

     Converts this mutable indexed sequence to a set.

     returns

       a set containing all elements of this mutable indexed sequence.

     Definition Classes
       TraversableOnce → GenTraversableOnce

175. #### def toStream: Stream[A]

     Converts this mutable indexed sequence to a stream.

     Converts this mutable indexed sequence to a stream.

     returns

       a stream containing all elements of this mutable indexed sequence.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

176. #### def toString(): String

     Converts this mutable indexed sequence to a string.

     Converts this mutable indexed sequence to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this mutable indexed sequence, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       SeqLike → TraversableLike → AnyRef → Any

177. #### def toTraversable: Traversable[A]

     Converts this mutable indexed sequence to an unspecified Traversable.

     Converts this mutable indexed sequence to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     returns

       a Traversable containing all elements of this mutable indexed sequence.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce

178. #### abstract def union(that: Seq[A]): IndexedSeq[A]

     [use case] Produces a new sequence which contains all elements of this mutable indexed sequence and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this mutable indexed sequence and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     that

       the sequence to add.

     returns

       a new collection of type `That` which contains all elements of this mutable indexed sequence followed by all elements of `that`.

     Definition Classes
       SeqLike

179. #### def union[B >: A, That](that: GenSeq[B])(implicit bf: CanBuildFrom[Repr, B, That]): That

     Produces a new sequence which contains all elements of this mutable indexed sequence and also all elements of a given sequence.

     Produces a new sequence which contains all elements of this mutable indexed sequence and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     B

       the element type of the returned mutable indexed sequence.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     that

       the sequence to add.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new collection of type `That` which contains all elements of this mutable indexed sequence followed by all elements of `that`.

     Definition Classes
       SeqLike → GenSeqLike

180. #### abstract def updated(index: Int, elem: A): IndexedSeq[A]

     [use case] A copy of this mutable indexed sequence with one single replaced element.

     [use case]

     A copy of this mutable indexed sequence with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a new mutable indexed sequence`which is a copy of this mutable indexed sequence with the element at position` index`replaced by` elem`.`

     Definition Classes
       GenSeqLike

181. #### def updated[B >: A, That](index: Int, elem: B)(implicit bf: CanBuildFrom[Repr, B, That]): That

     A copy of this mutable indexed sequence with one single replaced element.

     A copy of this mutable indexed sequence with one single replaced element.

     B

       the element type of the returned mutable indexed sequence.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     index

       the position of the replacement

     elem

       the replacing element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `B`.

     returns

       a new mutable indexed sequence`which is a copy of this mutable indexed sequence with the element at position` index`replaced by` elem`.`

     Definition Classes
       SeqLike → GenSeqLike

182. #### def view(from: Int, until: Int): IndexedSeqView[A, Repr]

     A sub-sequence view starting at index `from` and extending up to (but not including) index `until`.

     A sub-sequence view starting at index `from` and extending up to (but not including) index `until`.

     from

       The index of the first element of the slice

     until

       The index of the element following the slice

     returns

       a non-strict view of a slice of this mutable indexed sequence, starting at index `from` and extending up to (but not including) index `until`.@note The difference between `view` and `slice` is that `view` produces a view of the current sequence, whereas `slice` produces a new sequence.

     Definition Classes
       IndexedSeqLike → SeqLike → IterableLike → TraversableLike
     Note

       view(from, to) is equivalent to view.slice(from, to)

183. #### def view: IndexedSeqView[A, Repr]

     Creates a view of this iterable @see Iterable.

     Creates a view of this iterable @see Iterable.View

     returns

       a non-strict view of this mutable indexed sequence.

     Definition Classes
       IndexedSeqLike → SeqLike → IterableLike → TraversableLike

184. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

185. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

186. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

187. #### def withFilter(p: (A) ⇒ Boolean): FilterMonadic[A, Repr]

     Creates a non-strict filter of this mutable indexed sequence.

     Creates a non-strict filter of this mutable indexed sequence.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this mutable indexed sequence which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

188. #### abstract def zip[B](that: GenIterable[B]): IndexedSeq[(A, B)]

     [use case] Returns a mutable indexed sequence formed from this mutable indexed sequence and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a mutable indexed sequence formed from this mutable indexed sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this mutable indexed sequence and `that`. The length of the returned collection is the minimum of the lengths of this mutable indexed sequence and `that`.

     Definition Classes
       GenIterableLike

189. #### def zip[A1 >: A, B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[Repr, (A1, B), That]): That

     Returns a mutable indexed sequence formed from this mutable indexed sequence and another iterable collection by combining corresponding elements in pairs.

     Returns a mutable indexed sequence formed from this mutable indexed sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     B

       the type of the second half of the returned pairs

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this mutable indexed sequence and `that`. The length of the returned collection is the minimum of the lengths of this mutable indexed sequence and `that`.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike

190. #### abstract def zipAll[B](that: Iterable[B], thisElem: A, thatElem: B): IndexedSeq[(A, B)]

     [use case] Returns a mutable indexed sequence formed from this mutable indexed sequence and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a mutable indexed sequence formed from this mutable indexed sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this mutable indexed sequence is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this mutable indexed sequence.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this mutable indexed sequence and `that`. The length of the returned collection is the maximum of the lengths of this mutable indexed sequence and `that`. If this mutable indexed sequence is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this mutable indexed sequence, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

191. #### def zipAll[B, A1 >: A, That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[Repr, (A1, B), That]): That

     Returns a mutable indexed sequence formed from this mutable indexed sequence and another iterable collection by combining corresponding elements in pairs.

     Returns a mutable indexed sequence formed from this mutable indexed sequence and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this mutable indexed sequence is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this mutable indexed sequence.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this mutable indexed sequence and `that`. The length of the returned collection is the maximum of the lengths of this mutable indexed sequence and `that`. If this mutable indexed sequence is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this mutable indexed sequence, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike

192. #### abstract def zipWithIndex: IndexedSeq[(A, Int)]

     [use case] Zips this mutable indexed sequence with its indices.

     [use case]

     Zips this mutable indexed sequence with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this mutable indexed sequence paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

193. #### def zipWithIndex[A1 >: A, That](implicit bf: CanBuildFrom[Repr, (A1, Int), That]): That

     Zips this mutable indexed sequence with its indices.

     Zips this mutable indexed sequence with its indices.

     A1

       the type of the first half of the returned pairs (this is always a supertype of the collection's element type `A`).

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this mutable indexed sequence paired with their index. Indices start at `0`.

     Definition Classes
       IndexedSeqOptimized → IterableLike → GenIterableLike

### Deprecated Value Members

1. #### def elements: Iterator[A]

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `iterator' instead`

2. #### def equalsWith[B](that: Seq[B])(f: (A, B) ⇒ Boolean): Boolean

   Tests whether every element of this mutable indexed sequence relates to the corresponding element of another sequence by satisfying a test predicate.

   Tests whether every element of this mutable indexed sequence relates to the corresponding element of another sequence by satisfying a test predicate.

   B

     the type of the elements of `that`

   that

     the other sequence

   returns

     `true` if both sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this mutable indexed sequence and `y` of `that`, otherwise `false`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `corresponds` instead

3. #### def findIndexOf(p: (A) ⇒ Boolean): Int

   Returns index of the first element satisfying a predicate, or `-1`.

   Returns index of the first element satisfying a predicate, or `-1`.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) Use indexWhere(p) instead.

4. #### def findLastIndexOf(p: (A) ⇒ Boolean): Int

   Returns index of the last element satisfying a predicate, or -1.

   Returns index of the last element satisfying a predicate, or -1.

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `lastIndexWhere` instead

5. #### def first: A

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `head' instead`

6. #### def firstOption: Option[A]

   `None` if iterable is empty.

   `None` if iterable is empty.

   Definition Classes
     IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `headOption' instead`

7. #### def projection: SeqView[A, Repr]

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   returns a projection that can be used to call non-strict `filter`, `map`, and `flatMap` methods that build projections of the collection.

   Definition Classes
     SeqLike → IterableLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `view' instead`

8. #### def reversedElements: Iterator[A]

   Definition Classes
     SeqLike
   Annotations
     @deprecated
   Deprecated

     (Since version 2.8.0) use `reverseIterator' instead`

### Inherited from IndexedSeqOptimized[A, Repr]

### Inherited from IndexedSeqLike[A, Repr]

### Inherited from SeqLike[A, Repr]

### Inherited from GenSeqLike[A, Repr]

### Inherited from IterableLike[A, Repr]

### Inherited from GenIterableLike[A, Repr]

### Inherited from TraversableLike[A, Repr]

### Inherited from GenTraversableLike[A, Repr]

### Inherited from Parallelizable[A, ParSeq[A]]

### Inherited from TraversableOnce[A]

### Inherited from GenTraversableOnce[A]

### Inherited from FilterMonadic[A, Repr]

### Inherited from HasNewBuilder[A, Repr]

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any